/* FIXME: use inodes/free, too */
/* FIXME: calculation is broken: trunc too much */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <getopt.h>
#include <sys/time.h>

#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#if defined(__linux__)
#include <sys/vfs.h>    /* statfs(2) */
#endif
#include <sys/mount.h>  /* statfs(2) */
#include <sys/poll.h>

#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>

#include "wmgeneral.h"

#include "wmstatfs-master.xpm"
#include "wmstatfs-mask.xbm"

#define DEBUG(x) /*x*/

#if defined(__linux__)
#define MTAB "/proc/mounts"
#elif defined(SunOS)
#define MTAB "/etc/mnttab"
#else
#define MTAB "/etc/mtab"
#endif

#define FSTAB "/etc/fstab"

#define WMSTATFS_VERSION "1.3"

char *opt_part = "/";
int opt_freq = 10;
int opt_zoom = 1;

void chkerr(int err, char *text)
{
  if (err) {
    fprintf(stderr, "%s\n", text);
    exit(1);
  }
}

#define COLUMNS 54
#define HEIGHT 40
#define XLEFT 5
#define YBOTTOM 58

struct mtab {
  char *dev;
  char *mpt;
  char *typ;
  char *opt;
  char *parent;
  char init;    /* index to num[] and ino[], <0 otherwise */
  char mounted; /* according to mtab */
  struct statfs statfs;
  unsigned long num[COLUMNS];
  unsigned long ino[COLUMNS];
};

void ismounted(struct mtab *mtab)
{
  if (statfs(mtab->mpt, &mtab->statfs) < 0) {
    mtab->mounted = 0;
    return;
  }
  DEBUG(printf("ISMNT: ok, free=%ld\n", mtab->statfs.f_bfree));
}

int switch2(struct mtab *mtab)
{
  int i;
  DEBUG(printf("SWITCH1 -%s-\n", mtab->mpt));
  ismounted(mtab);
  if ((mtab->init < 0) && mtab->mounted) {
    DEBUG(printf("SWITCH2 -%s- ok\n", mtab->dev));
    for (i = 0; i < COLUMNS; i++) {
      mtab->num[i] = mtab->statfs.f_bfree;
      mtab->ino[i] = mtab->statfs.f_ffree;
    }
    mtab->init = 0;
  }
  return mtab->mounted;
}

const static struct {
  unsigned char x;
  unsigned char y;
} charmap[] = {
  {36,88}, /* SP */
  { 0, 0}, /* ! */
  { 0, 0},
  { 0, 0},
  { 0, 0},
  {42,88}, /* % */
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  {54,88}, /* / */
  { 0,64}, /* 0 */
  { 6,64},
  {12,64},
  {18,64},
  {24,64},
  {30,64},
  {36,64},
  {42,64},
  {48,64},
  {54,64}, /* 9 */
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0}, /* @ */
  { 0,72}, /* A */
  { 6,72},
  {12,72},
  {18,72},
  {24,72},
  {30,72},
  {36,72},
  {42,72},
  {48,72},
  {54,72},
  { 0,80},
  { 6,80},
  {12,80},
  {18,80},
  {24,80},
  {30,80},
  {36,80},
  {42,80},
  {48,80},
  {54,80},
  { 0,88},
  { 6,88},
  {12,88},
  {18,88},
  {24,88},
  {30,88}, /* Z */
  { 0, 0},
  { 0, 0},
  { 0, 0},
  { 0, 0},
  {48,88}  /* _ */
};

void drawtext(int x, int y, char *txt)
{
  int i, c, a, b;
  for (i = 0; (c = *txt++); i++) {
    if (c >= 96) {
      c = toupper(c);
    }
    if ((c >= ' ') && (c < 96)) {
      a = charmap[c - ' '].x;
      b = charmap[c - ' '].y;
      if (b != 0) {
        copyXPMArea(a, b, 6, 9, x, y);
        x += 6;
      }
    }
  }
}

void DrawActiveDEV(char *name)
{
  int i;
  char *s;
  cleararea(5, 5, 36, 10);
  s = strrchr(name, '/') + 1;
  i = strlen(s);
  if (i > 6) {
    s += i - 6;
  }
  drawtext(6, 5, s);
}

#define LED_MOUNT (53)
#define LED_FREE  (47)

#define LED_RED   (64)
#define LED_GREEN (68)
#define LED_GRAY  (72)

void SetLED(int led, int color)
{
  copyXPMArea(60, color, 4, 4, led, 7);
}

void calclimits(unsigned long *num, long total,
        double *blkperpix, unsigned long *blkbase0,
        unsigned long *ll, unsigned long *lh)
{
  int i;
  unsigned long f, g, h;
  double F, G, H;
  g = h = num[0];
  for (i = 1; i < COLUMNS; i++) {
    f = num[i];
    if (f < g) {
      g = f;
    }
    if (f > h) {
      h = f;
    }
  }
  DEBUG(printf("STAT1 r=%ld..%ld, b=%ld\n", g, h, total));
  F = total;
  F = F / opt_zoom;
  G = g;
  H = h;
  G = G / F;
  H = H / F;
  DEBUG(printf("STAT2 g=%ld, h=%ld, z=%d\n", g, h, opt_zoom));
  g = (int)G;
  h = (int)H;
  if ((h == 0) || (h != H) || (g == h)) {
    h += 1;
  }
  if (h > opt_zoom) {
    h = opt_zoom;
  }
  if (g >= h) {
    g = h-1;
  }
  DEBUG(printf("STAT4 F,G,H: %.5f, %.5f, %.5f; g,h = %ld,%ld\n",
    F, G, H, g, h));
  *blkbase0 = (int)(g * F);
  *blkperpix = (h - g) * F / HEIGHT;
  if (*blkperpix < 1) {
    *blkperpix = 1;
  }
  *lh = ((opt_zoom - g) * 100 + opt_zoom - 1) / opt_zoom;
  *ll = (opt_zoom - h) * 100 / opt_zoom;
}

void DrawStats(struct mtab *m)
{
  int i, x;
  unsigned long a, b;
  double blkperpix;
  unsigned long blkbase0;
  char tl[5], th[5];
  cleararea(XLEFT, YBOTTOM-HEIGHT, COLUMNS-1, HEIGHT);
  if (m->mounted) {
    calclimits(&m->ino[0], m->statfs.f_files, &blkperpix, &blkbase0, &a, &b);
    i = m->init;
    b = (int)((m->ino[i] - blkbase0) / blkperpix); /* free/total */
    DEBUG(printf("STAT5i B0=%ld, BP=%.5f, v=%ld\n", blkbase0, blkperpix, b));
    DEBUG(if((b < 0) || (b >= HEIGHT)) exit(1));
    for (x = 1; x < COLUMNS; x++) {
      a = b;
      if (++i >= COLUMNS) {
        i = 0;
      }
      b = (m->ino[i] - blkbase0) / blkperpix; /* free/total */
      darkline(XLEFT+x-1, YBOTTOM-HEIGHT+a, XLEFT+x, YBOTTOM-HEIGHT+b);
    }
    calclimits(&m->num[0], m->statfs.f_blocks, &blkperpix, &blkbase0, &a, &b);
    snprintf(&th[0], sizeof(th), "%3ld%%", b);
    snprintf(&tl[0], sizeof(tl), "%3ld%%", a);
    i = m->init;
    b = (int)((m->num[i] - blkbase0) / blkperpix); /* free/total */
    DEBUG(printf("STAT5b B0=%ld, BP=%.5f, v=%ld\n", blkbase0, blkperpix, b));
    DEBUG(if((b < 0) || (b >= HEIGHT)) exit(1));
    for (x = 1; x < COLUMNS; x++) {
      a = b;
      if (++i >= COLUMNS) {
        i = 0;
      }
      b = (m->num[i] - blkbase0) / blkperpix; /* free/total */
      drawline(XLEFT+x-1, YBOTTOM-HEIGHT+a, XLEFT+x, YBOTTOM-HEIGHT+b);
    }
    drawtext(XLEFT-4, YBOTTOM-HEIGHT, th);
    drawtext(XLEFT-4, YBOTTOM-9, tl);
  }
}

void getmtab(char *filename, struct mtab **mtab, int *num, int mnt)
{
  FILE *f;
  char *c;
  int l = *num;
  int i;
  struct stat s;
  struct mtab *m = *mtab;
  struct mtab *h;
  char line[256];
  char dev[256];
  char mpt[256];
  char typ[256];
  char opt[256];
  f = fopen(filename, "r");
  chkerr(f == NULL, "cannot open");
  h = m;
  for (i = 0; i < l; i++) {
    if (h->mounted > 0) {
      h->mounted = -1;
    }
    h++;
  }
  while (!feof(f)) {
    line[0] = 0;
    fgets(&line[0], sizeof(line), f);
    opt[0] = 0;
    sscanf(&line[0], "%s %s %s %s ", dev, mpt, typ, opt);
    c = strrchr(&mpt[0], '/');
    if ((c != NULL)
     && (!strncmp(dev, "/", 1))
     && (strlen(opt) != 0)) {
      h = m;
      i = 0;
      while ((i < l)
          && strcmp(mpt, h->mpt)) {
        i += 1;
        h++;
      }
      DEBUG(printf("MTAB3 i=%d, h=%p\n", i, h));
      if (h != NULL) {
        DEBUG(printf("MTAB4 i=%d, h=(%d,%s)\n", i, h->mounted, h->dev));
      }
      if (stat(dev, &s) == 0) {
        if ((i >= l)
         || (h == NULL)
         || (!h->mounted)
         || (strcmp(h->dev, dev))
         || (strcmp(h->typ, typ))
         || (strcmp(h->opt, opt))) {
          if (i < l) {
            free(h->dev);
            free(h->typ);
            free(h->opt);
            free(h->parent);
          } else {
            l += 1;
            m = realloc(m, l * sizeof(*m));
            h = &m[l-1];
            chkerr((h->mpt = strdup(mpt)) == NULL, "malloc failed");
          }
          chkerr((h->dev = strdup(dev)) == NULL, "malloc failed");
          chkerr((h->typ = strdup(typ)) == NULL, "malloc failed");
          chkerr((h->opt = strdup(opt)) == NULL, "malloc failed");
          if (c == mpt) {
            if (strlen(c) == 1) {
              h->parent = NULL;
            } else {
              c[1] = 0;
              chkerr((h->parent = strdup(mpt)) == NULL, "malloc failed");
            }
          } else {
            *c = 0;
            chkerr((h->parent = strdup(mpt)) == NULL, "malloc failed");
          }
          h->init = -1;
        }
      }
      if (i < l) {
        h->mounted = mnt;
      }
      DEBUG(printf("MTAB(%s,%s,%s,%s;%s,%d;%d)\n",
        h->dev, h->mpt, h->typ, h->opt, h->parent, h->mounted, l));
    }
  }
  chkerr((l == 0) && mnt, "no devices");
  *mtab = m;
  *num = l;
  fclose(f);
  h = m;
  for (i = 0; i < l; i++) {
    if (h->mounted < 0) {
      h->mounted = 0;
    }
    h++;
  }
}

void wmstatfs(int argc, char **argv, int numfs, struct mtab *mtab)
{
  int d;
  int cur = -1;
  XEvent Event;
  struct timeval tv, tn;
  int but_stat = -1;
  int oldled = LED_GRAY;
  getmtab(MTAB, &mtab, &numfs, 1);
  for (d = 0; d < numfs; d++) {
    if (!strcmp(mtab[d].mpt, "/")) {
      chkerr(!switch2(&mtab[d]), "statfs failed on /");
      cur = d;
    }
  }
  chkerr(cur == -1, "no entry for /");
  getmtab(MTAB, &mtab, &numfs, 1);
  for (d = 0; d < numfs; d++) {
    DEBUG(printf("START1 -%s- ? -%s-\n", mtab[d].mpt, opt_part));
    if (!strcmp(mtab[d].mpt, opt_part)) {
      switch2(&mtab[d]);
      cur = d;
    }
  }
  openXwindow(argc, argv, wmstatfs_master_xpm, wmstatfs_mask_bits,
        wmstatfs_mask_width, wmstatfs_mask_height);
  AddMouseRegion(0, 5, 5, 41, 15);
  DrawActiveDEV(mtab[cur].dev);
  gettimeofday(&tn, NULL);
  while (1) {
    struct mtab *m;
    int redraw = 0;
    int oldfree = mtab[cur].statfs.f_bfree;
    int ledfree;
    gettimeofday(&tv, NULL);
    if (((tv.tv_sec - tn.tv_sec) > 0)
     || ((tv.tv_sec == tn.tv_sec) && (tv.tv_usec >= tn.tv_usec))) {
      tn.tv_usec += 100000 * opt_freq;
      tn.tv_sec += tn.tv_usec / 1000000;
      tn.tv_usec %= 1000000;
      getmtab(MTAB, &mtab, &numfs, 1);
      m = &mtab[cur];
      switch2(m);
      if (m->mounted) {
        if (m->statfs.f_bavail > 0) {
          SetLED(LED_MOUNT, LED_GREEN);
        } else {
          SetLED(LED_MOUNT, LED_RED);
        }
        DEBUG(printf("LOOP1 i=%d, free=%ld\n", m->init, m->statfs.f_bfree));
        m->num[(int)m->init] = m->statfs.f_bfree;
        m->ino[(int)m->init] = m->statfs.f_ffree;
        if (++m->init >= COLUMNS) {
          m->init = 0;
        }
      } else {
        SetLED(LED_MOUNT, LED_GRAY);
      }
      DrawStats(m);
      redraw = 1;
    } else {
      m = &mtab[cur];
      switch2(m);
    }
    if ((!m->mounted) || (oldfree == mtab[cur].statfs.f_bfree)) {
      ledfree = LED_GRAY;
    } else if (oldfree > mtab[cur].statfs.f_bfree) {
      ledfree = LED_RED;
    } else {
      ledfree = LED_GREEN;
    }
    if (ledfree != oldled) {
      oldled = ledfree;
      SetLED(LED_FREE, ledfree);
      redraw = 1;
    }
    while (XPending(display)) {
      XNextEvent(display, &Event);
      switch (Event.type) {
      case Expose:
        redraw = 1;
        break;
      case DestroyNotify:
        XCloseDisplay(display);
        exit(0);
        break;
      case ButtonPress:
        but_stat = CheckMouseRegion(Event.xbutton.x, Event.xbutton.y);
        break;
      case ButtonRelease:
        if (but_stat == CheckMouseRegion(Event.xbutton.x, Event.xbutton.y)
         && but_stat >= 0) {
          switch (but_stat) {
          case 0 :
            getmtab(MTAB, &mtab, &numfs, 1);
            cur += 1;
            if (cur >= numfs) {
              cur = 0;
            }
            switch2(&mtab[cur]);
            gettimeofday(&tn, NULL);
            break;
          }
        }
        but_stat = -1;
        DrawActiveDEV(mtab[cur].dev);
        redraw = 1;
        break;
      }
    }
    if (redraw) {
      RedrawWindow();
    }
    poll (NULL, 0, 50);
  }
}

void usage(char *arg0)
{
  fprintf(stderr,
    "Usage: %s [OPTION]...\n"
    "Filesystem Statistics as Windowmaker Applet\n"
    "\n"
    "  -h, --help\t\tshow this help\n"
    "  -V\t\t\tshow the version (" WMSTATFS_VERSION ")\n"
    "  -d, --device <path>\tshow stats for the device at mount point <path>\n"
    "  -f, --freq <time>\tset frequency to <time> tenth seconds\n"
    "  -z, --zoom <factor>\tzoom into the graph by <factor>\n",
    arg0);
}

void chkoptions(int argc, char *argv[])
{
  static const struct option longopt[] = {
    {"device", 1, NULL, 'd'},
    {"freq", 1, NULL, 'f'},
    {"zoom", 1, NULL, 'z'},
    {"version", 0, NULL, 'V'},
    {"help", 0, NULL, 'h'},
    {0, 0, 0, 0}
  };
  int i;
  int optindex;
  char *endptr;
  while ((i = getopt_long (argc, argv, "hVd:f:z:", longopt, &optindex)) >= 0) {
    switch (i) {
    case 'd':
      if (optarg) {
        opt_part = optarg;
      } else {
        usage(argv[0]);
        exit(1);
      }
      break;
    case 'f':
      if (optarg) {
        opt_freq = strtol(optarg, &endptr, 10);
        if (*endptr != 0) {
          usage(argv[0]);
          exit(1);
        }
      } else {
        usage(argv[0]);
        exit(1);
      }
      break;
    case 'z':
      if (optarg) {
        opt_zoom = strtol(optarg, &endptr, 10);
        if (*endptr != 0) {
          usage(argv[0]);
          exit(1);
        }
      } else {
        usage(argv[0]);
        exit(1);
      }
      if (opt_zoom <= 0) {
        opt_zoom = 1;
      }
      break;
    case 'V':
      fprintf(stderr, "%s\n", WMSTATFS_VERSION);
      exit(0);
      break;
    case 'h':
      usage(argv[0]);
      exit(0);
      break;
    default:
      usage(argv[0]);
      exit(1);
      break;
    }
  }
}

int main(int argc, char *argv[])
{
  int l = 0;
  struct mtab *mtab = NULL;
  chkoptions(argc, argv);
  getmtab(FSTAB, &mtab, &l, 0);
  getmtab(MTAB, &mtab, &l, 1);
  wmstatfs(argc, argv, l, mtab);
  return 0;
}

